import React, { MutableRefObject } from 'react';
import { IViewList } from '@devesharp/react-hooks';

export type IFilterComponent<T = any> = React.FunctionComponent<{
   handleFilters: (v: () => T) => void;
   filters: T;
}>;

export interface IPageListingProps {
   viewList: IViewList;
   // FiltersComponent: IFilterComponent;
   // tabs?: IPropsTabs;
   // tagsFilters?: Partial<IPropsTagFilter>;
   // sortOptions?: {
   //    name: any;
   //    value: any;
   // }[];
   // renderResource: (resource: any, index: number) => JSX.Element;
   // renderResourceSkeleton?: (resource: any, index: number) => JSX.Element;
}

export interface IPageListingChildrenProps extends IViewList {
   listingElRef: MutableRefObject<any>;
   updateFilters: (data: any) => void;
   clearFilters: () => void;
   updateFiltersDebounce: (data: any) => void;
   applyFiltersDebounce: () => void;
   currentPage: number;
   setPage: (page: number) => void;
   filterMobileOpen: boolean;
   openFilters: () => void;
   closeFilters: () => void;
   pageCountStart: number;
   pageCountEnd: number;
   showCardsSkeleton: boolean;
   showCards: boolean;
}
